#pragma once
#include "Module.h"
#include  <atlbase.h>

namespace InventorNative{

	class CAddInServerIDisp : ApplicationAddInServer // IDispatch
	{
	public:

		CAddInServerIDisp();
		//IUnknown
		virtual HRESULT __stdcall QueryInterface(const IID& iid,/*[in]*/
												 void **ppv); /*[iid_is][out]*/
		virtual ULONG __stdcall AddRef(void);
		virtual ULONG __stdcall Release(void);
		//IDispath
		virtual HRESULT __stdcall GetTypeInfoCount(UINT *pctinfo);/*[out]*/

		virtual HRESULT __stdcall GetTypeInfo(UINT iTInfo,/*[in]*/
											  LCID lcid, /*[in]*/
											  ITypeInfo **ppTInfo); /*[out]*/

		virtual HRESULT __stdcall GetIDsOfNames(const IID& riid,/*[in]*/
												LPOLESTR *rgszNames,/*[size_is][in]*/
												UINT cNames,/*[range][in]*/
												LCID lcid,/*[in]*/
												DISPID *rgDispId);/*[size_is][out]*/

		virtual  HRESULT __stdcall Invoke(DISPID dispIdMember,/*[in]*/
										  const IID& riid,/*[in]*/
										  LCID lcid,/*[in]*/
										  WORD wFlags,/*[in]*/
										  DISPPARAMS *pDispParams,/*[out][in]*/
										  VARIANT *pVarResult,/*[out]*/
										  EXCEPINFO *pExcepInfo,/*[out]*/
										  UINT *puArgErr);/*[out]*/
		// 
		HRESULT __stdcall MethodActivate(ApplicationAddInSite * pAddInSite,
										 VARIANT_BOOL FirstTime);
		HRESULT __stdcall MethodDeactivate();
		HRESULT __stdcall MethodExecuteCommand(long CommandID);
		IDispatchPtr __stdcall  GetAutomation();

	private:
		long m_cRef;// 
		Application * m_pInvApp;//  
	};
}