#pragma once
#include "Module.h"

namespace InventorNative{

	class CAddInServerIUnk : IRxApplicationAddInServer //COM 
	{
	public:
		virtual HRESULT __stdcall QueryInterface(const IID& iid,/*[in]*/
												 void **ppv); /*[iid_is][out]*/
		virtual ULONG __stdcall AddRef(void);
		virtual ULONG __stdcall Release(void);
		virtual	HRESULT __stdcall raw_Activate(IRxApplicationAddInSite * pAddInSite, /*[in]*/
											   BooleanType FirstTime);/*[in]*/
		virtual	HRESULT __stdcall raw_Deactivate();
		virtual HRESULT __stdcall raw_ExecuteCommand(long CommandID);
		virtual HRESULT __stdcall get_Automation(IUnknown **ppResult);

		CAddInServerIUnk();
	private:
		long m_cRef;// 
		Application * m_pInvApp;
	};
}