#pragma once
#include "Module.h"


class CClassFactory : public IClassFactory
{
public:
	virtual HRESULT __stdcall QueryInterface(const IID& iid, void** ppv);
	virtual ULONG __stdcall AddRef();
	virtual ULONG __stdcall Release();
	virtual HRESULT __stdcall CreateInstance(IUnknown* pUnknownOuter,//__nullptr
											 const IID& iid,//[in]
											 void** ppv);//[out]
	virtual HRESULT __stdcall LockServer(BOOL bLock);

	CClassFactory();
private:
	long m_cRef;
};
