#include "stdafx.h"
#include "NativeCode.h"
#include <WTypes.h>
#include <string>
using namespace InventorNative;

CNativeCode::CNativeCode()//
{
	HRESULT Result = NOERROR;
	//  Inventor
	//{B6B5DC40-96E3-11d2-B774-0060B0F159EF}
	const CLSID InvAppClsid = { 0xB6B5DC40, 0x96E3, 0x11d2,
	{ 0xB7, 0x74, 0x00, 0x60, 0xB0, 0xF1, 0x59, 0xEF } };
	//Result = CLSIDFromProgID(L"Inventor.Application", &InvAppClsid);
	// -  IUnknown
	CComPtr<IUnknown> pInvAppUnk;
	Result = ::GetActiveObject(InvAppClsid, __nullptr, &pInvAppUnk);
	//  Inventor
	Result = pInvAppUnk->QueryInterface(__uuidof(Application), (void **)&pInvApp);
}

CNativeCode::~CNativeCode()//
{
}

void CNativeCode::ShowMassage()//  
{
	HRESULT Result = NOERROR;
	// 
	CComBSTR bstrCaption;
	Result = pInvApp->get_Caption(&bstrCaption);
	//  
	CComBSTR bstrMsgText(L"Native C++:  ");
	bstrMsgText.AppendBSTR(bstrCaption);
	// 
	int msgboxID = MessageBoxW(__nullptr, bstrMsgText, L"", MB_OK);
	//   Inventor.Caption
	CComBSTR bstrNewCaption(L"  Inventor");
	Result = pInvApp->put_Caption(bstrNewCaption);
}